// Medusa is a graph viewer which allows interactive editing of networks
// (edges and nodes) and also connects to databases.
//
// Copyright (C) 2006 Sean Hooper
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License as published by 
// the Free Software Foundation; either version 2 of the License, or (at 
// your option) any later version.
//
// This program is distributed in the hope that it will be useful, but 
// WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
// Public License for more details.
//
// You should have received a copy of the GNU General Public License along 
// with this program; if not, write to the 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, 
// Boston, MA 02111-1307 USA

package medusa;

import medusa.graph.Edge;
import medusa.graph.Graph;
import medusa.graph.Node;


public class DemoTools{
    
    public Graph randomGraph(int nNodes, int nEdges){
	// based on a limited number of nodes
	Graph graph=new Graph();
	Edge temp;
	String n1;
	String n2;
	for (int i=0; i<nEdges;i++){
	    n1= randomNode(nNodes);
	    n2= randomNode(nNodes);
	    temp=new Edge(n1,n2,(float)Math.random(),randomInteraction());
	    graph.addEdge(temp);
	}
	setNodes(graph);
	return graph;
    }

    private void setNodes(Graph graph){
	int shape=0;
	int red=255;
	int green=255;
	int blue=255;
	for (java.util.Iterator it = graph.nodesIterator(); it.hasNext();) {
            Node node = (Node)it.next();
	    shape = (int)(Math.random()*4);
	    red = (int)(Math.random()*255);
	    green = (int)(Math.random()*255);
	    blue = (int)(Math.random()*255);
	    node.setShape(shape);
	    node.setColor(new java.awt.Color(red,green,blue));
            
	}
    }
    
    private String randomNode(int nNodes){
	int index = (int)(Math.random()*nNodes);
	return "n"+index;
    }
    
    private int randomInteraction(){
       int inter= (int)(Math.random()*6+1);
       return inter;
    }
    
    public static void main(String[] args){
	DemoTools dt = new DemoTools();
	int nNodes=10;
	int nEdges=10;
	Graph g = dt.randomGraph(nNodes, nEdges);
	System.out.println(g.report());
	
    }

}
